# BACHELOR THESIS - BI-BAP 
Daniel Králík
kralidan
Department of Computer Science
FIT CTU

# Structure
+--`README.md`                  the file with CD contents description
|--`exe`                        the directory with executables
|--`src`--+                     the directory of source codes
|         |--`wbdcm`            implementation sources
|         \\--`thesis`           the directory of LATEX source codes of the thesis
\\--`text`--+                   the thesis text directory
           |--`thesis.pdf`      the thesis text in PDF format
           \\--`thesis.ps`       the thesis text in PS format 


# Characteristics of sources
Concise characteristics of sources.

#========================================================
#------------------------ <EXE> ------------------------- 
#========================================================
We should find in this folder three executable files: - `illinois_scan`, `scan_generator`,`simulator`. If program has got on this end parameter `-name` $output, than illinois scan write to $output else to $stdout (std::cout).

#--------------------------------------------------------
# < illinois_scan >
This program serves to generate from origin file of sequential or combinational logic (BLIF) to illinois scan architecture (BLIF) according to scan-chains. 

Using of program is following:
`./illinois_scan` $input `-scan_name` $scan_input                      # print illinois-scan to $stdout according to file $scan_input                    
                         `-scan_random` #scan-chains length(modulo)    # print illinois-scan to $stdout from generated #random length scan-chains 
                         `-scan_number` #number_of_scan-chains         # print illinois-scan to $stdout from generated #number scan-chains 
                         `-scan_size` #size_of_scan_chains             # print illinois-scan to $stdout from generated #size length scan-chains 

`./illinois_scan` $input -test                                         # print illinois-scan to $stdout in test mode for ATPG with serial scan-chain
`./illinois_scan` $input                                               # print illinois-scan to $stdout with scan cells
`./illinois_scan` $input `...` $... `-name` $output                    # print illinois-scan to $output according parametres

examples (on linux):
./illinois_scan ../src/wbdcm/samples/s27.blif -scan_random 3
./illinois_scan ../src/wbdcm/samples/s27.blif -scan_number 3
./illinois_scan ../src/wbdcm/samples/s27.blif -scan_size 3
./illinois_scan ../src/wbdcm/samples/s27.blif -scan_name scan.txt

scan.txt:
G3 G5 
G1 G0 
G7 
G6 G2 

#--------------------------------------------------------
# < scan_generator >
This program generates scan-chains from origin file of sequential or combinational logic (BLIF)


Using of program is following:
`./scan_generator` $input `-scan_random` #scan-chains_length(modulo)    # print scan-chains to $stdout from generated #random length scan-chains 
                          `-scan_number` #number_of_scan-chains         # print scan-chains to $stdout from generated #number scan-chains 
                          `-scan_size` #size_of_scan_chains             # print scan-chains to $stdout from generated #size length scan-chains 

`./scan_generator` $input `...` $... `-name` $output                    # print scan-chains to $output file according parametres

examples(on linux):
./scan_generator ../src/wbdcm/samples/s27.blif -scan_random 3
./scan_generator ../src/wbdcm/samples/s27.blif -scan_number 3
./scan_generator ../src/wbdcm/samples/s27.blif -scan_size 3

#--------------------------------------------------------
# < simulator >
This program serves to generate from origin file of sequential or combinational logic (BLIF) to illinois scan architecture (BLIF) according to scan-chains. 

Using of program is following:
`./simulator` $input `-vector` $binary_input_vector            # print vector of outputs to $stdout                     
                     `-matrix` $file_name_matrix_of_vectors    # print matrix of outputs to $stdout 

`./simulator` $input `...` $... `-name` $output                # print vector(s) to $output according parametres
`./simulator` $input `...` $... `-input`                       # print input and output vector(s) according parametres
`./simulator` $input `...` $... `-name` $output `-input`       # print input and output vector(s) to the $output according parametres

example (on linux):
./simulator ../src/wbdcm/samples/s27.blif -vector 0001110
./simulator ../src/wbdcm/samples/s27.blif -matrix matrix.txt

matrix.txt:
0001110
0101010
1010101
0000000
1111111

#========================================================
#------------------------ <SRC> ------------------------- 
#========================================================
We should find in this folder LATEX sources and program's sources - `thesis`, `wbdcm`.

#--------------------------------------------------------
# < wbdcm >
Sources of program are written in C++11 language. We should have five folders in $wbdcm: 
`global` - Shared sources using with projects.
`illinois_scan` - Sources of $illinois_scan.
`samples` - Sources with BLIF examples. Experimental measurment are based on this files.
`scan_generator` - Sources of $scan_generator.
`simulator` - Sources of $simulator.

You could compile with following commands in folders $illinois_scan, $scan_generator, $simulator:
1.calling
`cmake ./ & make`  # first calling - build files are written to current folder
2.calling
`cmake ./ & make`  # second calling - linking CXX executable program

In current folder is generated build files and `illinois_scan`, `scan_generator`, `simulator` executable programs. 



#--------------------------------------------------------
# < thesis >
Sources of thesis in latex. You could open in any latex editor - TemplateBachelorThesis.tex (recommended TEXMAKER).   


#========================================================
#----------------------- <TEXT> ------------------------- 
#========================================================

#--------------------------------------------------------
# < thesis.pdf >
Bachelor thesis in pdf format.

#--------------------------------------------------------
# < thesis.ps >
Bachelor thesis in ps format.
