//
// Created by daniel on 21.5.20.
//

#ifndef PROGRAM_SEARCH_H
#define PROGRAM_SEARCH_H

/*
 * --------------------------------------------
 * Blif file - Subfile Reference
 * --------------------------------------------
 *
 * A subfile-reference is:
 *
 * .search <file-name>
 *
 * file-name gives the name of the file to search.
 *
 * A subfile-reference directs the BLIF reader to read in and define all the models in file file-name. A subfile-
 * reference does not have to be inside of a .model. subfile-references can be nested.
 *
 * Search files would usually be used to hold all the subcircuits referred to in model-references, while the master
 * file merely searches all the subfiles and instantiates all the subcircuits it needs.
 *
 * A subfile-reference is not equivalent to including the body of subfile file-name in the current file. It does not
 * patch fragments of BLIF into the current file; it pauses reading the current file, reads file-name as an independent,
 * self-contained file, then returns to reading the current file.
 *
 * The first .model in the master file is always the one returned to the user, regardless of any subfile-references
 * than may precede it.
 *
 */

class Search {
public:

private:
};

#endif //PROGRAM_SEARCH_H
